load "buchberger.m2";
load "membership.m2";

dimension = method ()
dimension (Ideal) := ZZ => (I) -> (
R:=ring(I);
R':=QQ[gens(R),MonomialOrder=>GRevLex];
I=substitute(I,R');--betrachte I unter GRevLex-Monomordnung

--berechne Gröbnerbasis von I
G:=buchberger(I);
--Gröbnerbasis ist Erzeugendensytem des Leitideals

inI:=ideal(for g in G list leadMonomial(g));
--bestimmte Dimension von inI mittels brute-force
X:=gens(R');
numVars:={};
--nicht empfehlenswert für Polynomringe mit vielen Variablen!
for Vars in subsets(X) do (
   if #Vars>0 then (
   P:=ideal(Vars);
--prüfe, ob P über inI liegt
   isSubset:=true;
   for f in inI_* do (
       if membership(P,f)==false then (
           isSubset=false;
           );
       );
   if isSubset==true then (
-- P liegt über inI, speichere Anzahl der Variablen in P   
       numVars=numVars|{#Vars};
       );
    );
   );

return #gens(R')-min(numVars);

);
